attribute vec3 inPosition;
attribute vec4 inTexCoord;
attribute float inSize;

uniform mat4 g_WorldViewProjectionMatrix;
uniform mat4 g_WorldViewMatrix;
uniform mat4 g_WorldMatrix;
uniform mat4 g_ProjectionMatrix;

varying vec2 texCoord;

void main(){
    vec4 modelSpacePos = vec4(inPosition, 1.0);
    
    vec2 corner = inTexCoord.xy;
    
    //#ifdef SCREEN_PARALLEL
        vec3 wvPosition = (g_WorldViewMatrix * modelSpacePos).xyz;
        wvPosition.x += (corner.x - 0.5) * inSize;
        wvPosition.y += (corner.y - 0.5) * inSize;
        
        // Push it away a little bit to see if it helps with the hard
        // shadow line when the billboarded quads end up shadowing themselves
        wvPosition.z -= inSize * 0.5;
    
        gl_Position = g_ProjectionMatrix * vec4(wvPosition, 1.0);
    /*#else

        // Grab the world view position early because we will
        // base billboarding off of this.  We could do billboarding
        // directly in worldview space but then it would crawl
        // around as the camera turns.  So we'll do it in world space.
        vec4 wPosition = g_WorldMatrix * modelSpacePos; 

        // Calculate the screen parallel axis vectors
        vec3 dir = normalize(wPosition.xyz - g_CameraPosition);
        vec3 left = normalize(cross(dir, vec3(0.0, 1.0, 0.0)));
        vec3 up = normalize(cross(left, dir)); 
        vec3 billboardNormal = normalize(cross(left, up)); 

        // Derive the position and normal from the texture coordinates
        //wvPosition.xyz += g_CamLeft * (texCoord.x - 0.5);
        //wvPosition.xyz += g_CamUp * (texCoord.y - 0.5);
     
        //wPosition.xyz += left * (texCoord.x - 0.5); 
        //wPosition.xyz += up * (texCoord.x - 0.5);
        wPosition.xyz += left * (corner.x - 0.5) * 3.0;
        wPosition.xyz += up * (corner.y - 0.5) * 3.0;
        //wPosition.x += texCoord.x - 0.5; 
        //wPosition.y += texCoord.y - 0.5; 

        vec3 wvPosition = (g_ViewMatrix * wPosition).xyz; 

        gl_Position = g_ViewProjectionMatrix * wPosition;
 
        vec3 wNormal = (g_WorldMatrix * vec4(modelSpaceNorm, 0.0)).xyz * 0.1; 
        wNormal += left * (corner.x - 0.5);        
        wNormal += up * (corner.y - 0.5);
        wNormal += billboardNormal * 0.5;
        //wNormal = normalize(wNormal);
        //vec3 wNormal = billboardNormal;
        //vec3 wNormal = (g_WorldMatrix * vec4(modelSpaceNorm, 0.0)).xyz;
                
        vec3 wvNormal = normalize((g_ViewMatrix * vec4(wNormal, 0.0)).xyz); 
        
    #endif*/
    
    
    //modelSpacePos.x += 10.0;
    
    //modelSpacePos.x -= (corner.x - 0.5);
    //modelSpacePos.y += (corner.y - 0.5);
    //gl_Position = g_WorldViewProjectionMatrix * modelSpacePos;
    texCoord = inTexCoord.zw;
}
