#ifdef USE_TEXTURE
uniform sampler2D m_Texture;
varying vec4 texCoord;
#endif

uniform float g_Time;

varying vec4 color;

void main(){
    if (color.a <= 0.01)
        discard;

    #ifdef USE_TEXTURE
        float multiplier = 1.0;
        #ifdef POINT_SPRITE
            float time = mod(g_Time * 0.25, 1.0);
            vec2 radial = (gl_PointCoord.xy - vec2(0.5, 0.5)) * 2.0;
            float d = dot(radial, radial);
            //vec2 uv = mix(texCoord.xy, texCoord.zw, (gl_PointCoord.xy + vec2(time, 0.0) - radial));
            vec2 warp = normalize(radial) * d * d;
            vec2 uv = mix(texCoord.xy, texCoord.zw, (gl_PointCoord.xy + vec2(time * 2.0, 0.0) + warp));
 
            multiplier = step(d, 1.0);
        #else
            vec2 uv = texCoord.xy;
        #endif        
        gl_FragColor = (texture2D(m_Texture, uv) * color) * multiplier;
    #else
        gl_FragColor = color;
    #endif
}
